const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const comments = sequelize.define(
    'comments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

body: {
        type: DataTypes.TEXT,
      
      

      },

posted_at: {
        type: DataTypes.DATE,
      
      

      },

is_edited: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  comments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















    db.comments.hasMany(db.comment_reactions, {
      as: 'comment_reactions_comment',
      foreignKey: {
          name: 'commentId',
      },
      constraints: false,
    });


    db.comments.hasMany(db.mentions, {
      as: 'mentions_comment',
      foreignKey: {
          name: 'commentId',
      },
      constraints: false,
    });













//end loop



    db.comments.belongsTo(db.comment_threads, {
      as: 'thread',
      foreignKey: {
        name: 'threadId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.users, {
      as: 'author',
      foreignKey: {
        name: 'authorId',
      },
      constraints: false,
    });

    db.comments.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.comments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.comments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return comments;
};


